package com.takensoft.ai_lms.lms.unit_learning.dao;

import com.takensoft.ai_lms.lms.unit_learning.vo.UnitLearningVO;
import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import java.util.List;

/**
 * @author  : 구자현
 * @since   : 2024.07.26
 *
 * 로드맵 관련 Mapper
 */
@Mapper("unitLearningDAO")
public interface UnitLearningDAO {

    /**
     * @author  : 구자현
     * @since   : 2024.07.26
     *
     * 전체 로드맵 목록 출력
     */
    List<UnitLearningVO> getAllUnitLearning();

    /**
     * @author  : 구자현
     * @since   : 2024.07.26
     *
     * 로드맵의 상세 정보
     */
    UnitLearningVO getUnitLearningBySeq(int seq);

    /**
     * @author  : 구자현
     * @since   : 2024.07.26
     *
     * 로드맵 등록
     */
    void insertUnitLearning(UnitLearningVO scheduleVO);

    /**
     * @author  : 구자현
     * @since   : 2024.07.26
     *
     * 로드맵 순서 수정
     */
    void updateUnitLearning(UnitLearningVO scheduleVO);

    /**
     * @author  : 구자현
     * @since   : 2024.07.26
     *
     * 로드맵 삭제
     */
    void deleteUnitLearning(int seq);
}
