package com.takensoft.ai_lms.lms.unit_learning.web;

import com.takensoft.ai_lms.lms.unit_learning.service.Impl.UnitLearningServiceImpl;
import com.takensoft.ai_lms.lms.unit_learning.vo.UnitLearningVO;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RequiredArgsConstructor
@RestController
@RequestMapping("/unitLearning")
public class UnitLearningController {

    private final UnitLearningServiceImpl unitLearningServiceImpl;

    /**
     * @author  : 구자현
     * @since   : 2024.07.26
     *
     * 전체 로드맵 목록 출력
     */
    @GetMapping("/findAll.json")
    public List<UnitLearningVO> getAllUnitLearning(){
        return unitLearningServiceImpl.getAllUnitLearning();
    }

    /**
     * @author  : 구자현
     * @since   : 2024.07.26
     *
     * 로드맵의 상세 정보
     */
    @GetMapping("/find.json")
    public UnitLearningVO getUnitLearningBySeq(@RequestBody UnitLearningVO unitLearningVO){
        return unitLearningServiceImpl.getUnitLearningBySeq(unitLearningVO.getSeq());
    }

    /**
     * @author  : 구자현
     * @since   : 2024.07.26
     *
     * 로드맵 등록
     */
    @PostMapping("/insert.json")
    public void insertUnitLearning(@RequestBody UnitLearningVO unitLearningVO) {
        unitLearningServiceImpl.insertUnitLearning(unitLearningVO);
    }

    /**
     * @author  : 구자현
     * @since   : 2024.07.26
     *
     * 로드맵 순서 수정
     */
    @PutMapping("/update.json")
    public void updateUnitLearning(@RequestBody UnitLearningVO unitLearningVO) {
        unitLearningServiceImpl.updateUnitLearning(unitLearningVO);
    }

    /**
     * @author  : 구자현
     * @since   : 2024.07.26
     *
     * 로드맵 삭제
     */
    @DeleteMapping("/delete.json")
    public void deleteUnitLearning(@RequestBody UnitLearningVO unitLearningVO) {
        unitLearningServiceImpl.deleteUnitLearning(unitLearningVO.getSeq());
    }
}
